package com.sd.business.controller.production;

import com.ruoyi.common.core.domain.BaseSelectDto;
import com.sd.business.entity.order.dto.SkuSpecPackageBomDto;
import com.sd.business.entity.order.vo.OrderSkuVo;
import com.sd.business.entity.production.dto.ProductionExceedReceiveDto;
import com.sd.business.entity.production.vo.OutBomVo;
import com.sd.business.service.order.OrderSkuService;
import com.sd.business.service.production.ProductionExceedReceiveService;
import com.sd.business.service.sku.SkuSpecService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 生产超领
 */
@RestController
@RequestMapping("/productionExceedReceive")
public class ProductionExceedReceiveController {

    @Autowired
    private OrderSkuService orderSkuService;

    @Autowired
    private SkuSpecService skuSpecService;

    @Autowired
    private ProductionExceedReceiveService productionExceedReceiveService;

    /**
     * 生产超领
     */
    @PostMapping("/exceedReceive")
    public void exceedReceive(@Validated @RequestBody ProductionExceedReceiveDto dto) {
        productionExceedReceiveService.exceedReceive(dto);
    }

    /**
     * 获取订单sku列表
     */
    @PostMapping("/getOrderSkuList")
    public List<OrderSkuVo> getOrderSkuList(@RequestBody BaseSelectDto dto) {
        return orderSkuService.getOrderSkuList(dto.getId());
    }

    /**
     * 获取sku所有材料明细列表
     */
    @PostMapping("/getSkuSpecMaterialList")
    public List<OutBomVo> getSkuSpecMaterialList(@RequestBody SkuSpecPackageBomDto dto) {
        return skuSpecService.getSkuSpecMaterialList(dto);
    }

    /**
     * 生产错误超领
     */
    @PostMapping("/errorExceedReceive")
    public void errorExceedReceive(@Validated @RequestBody ProductionExceedReceiveDto dto) {
        productionExceedReceiveService.errorExceedReceive(dto);
    }

    /**
     * 计划外超领生产
     */
    @PostMapping("/unplannedExceedReceive")
    public void unplannedExceedReceive(@Validated @RequestBody ProductionExceedReceiveDto dto) {
        productionExceedReceiveService.unplannedExceedReceive(dto);
    }
}
